com.sun.jna.platform.win32

## Interface Shell32

- All Superinterfaces:
    AltCallingConvention, Library, ShellAPI, StdCall, StdCallLibrary

      public interface Shell32
      extends ShellAPI, StdCallLibrary

  Shell32.dll Interface.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.sun.jna.platform.win32.ShellAPI

      `ShellAPI.APPBARDATA, ShellAPI.SHFILEOPSTRUCT`

    - ### Nested classes/interfaces inherited from interface com.sun.jna.win32.StdCallLibrary

      `StdCallLibrary.StdCallCallback`

    - ### Nested classes/interfaces inherited from interface com.sun.jna.Library

      `Library.Handler`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Shell32` | `INSTANCE`

    - ### Fields inherited from interface com.sun.jna.platform.win32.ShellAPI

      `ABE_BOTTOM, ABE_LEFT, ABE_RIGHT, ABE_TOP, ABM_ACTIVATE, ABM_GETAUTOHIDEBAR, ABM_GETSTATE, ABM_GETTASKBARPOS, ABM_NEW, ABM_QUERYPOS, ABM_REMOVE, ABM_SETAUTOHIDEBAR, ABM_SETPOS, ABM_SETSTATE, ABM_WINDOWPOSCHANGED, FO_COPY, FO_DELETE, FO_MOVE, FO_RENAME, FOF_ALLOWUNDO, FOF_CONFIRMMOUSE, FOF_FILESONLY, FOF_MULTIDESTFILES, FOF_NO_CONNECTED_ELEMENTS, FOF_NO_UI, FOF_NOCONFIRMATION, FOF_NOCONFIRMMKDIR, FOF_NOCOPYSECURITYATTRIBS, FOF_NOERRORUI, FOF_NORECURSEREPARSE, FOF_NORECURSION, FOF_RENAMEONCOLLISION, FOF_SILENT, FOF_SIMPLEPROGRESS, FOF_WANTMAPPINGHANDLE, FOF_WANTNUKEWARNING, PO_DELETE, PO_PORTCHANGE, PO_REN_PORT, PO_RENAME, STRUCTURE_ALIGNMENT`

    - ### Fields inherited from interface com.sun.jna.win32.StdCallLibrary

      `FUNCTION_MAPPER, STDCALL_CONVENTION`

    - ### Fields inherited from interface com.sun.jna.Library

      `OPTION_ALLOW_OBJECTS, OPTION_CALLING_CONVENTION, OPTION_CLASSLOADER, OPTION_FUNCTION_MAPPER, OPTION_INVOCATION_MAPPER, OPTION_OPEN_FLAGS, OPTION_STRING_ENCODING, OPTION_STRUCTURE_ALIGNMENT, OPTION_TYPE_MAPPER`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `WinDef.UINT_PTR` | `SHAppBarMessage(WinDef.DWORD dwMessage, ShellAPI.APPBARDATA pData)` SHAppBarMessage function
    `WinDef.INT_PTR` | `ShellExecute(WinDef.HWND hwnd, java.lang.String lpOperation, java.lang.String lpFile, java.lang.String lpParameters, java.lang.String lpDirectory, int nShowCmd)` Performs an operation on a specified file.
    `int` | `SHFileOperation(ShellAPI.SHFILEOPSTRUCT fileop)` This function can be used to copy, move, rename, or delete a file system object.
    `WinNT.HRESULT` | `SHGetDesktopFolder(PointerByReference ppshf)` Retrieves the IShellFolder interface for the desktop folder, which is the root of the Shell's namespace.
    `WinNT.HRESULT` | `SHGetFolderPath(WinDef.HWND hwndOwner, int nFolder, WinNT.HANDLE hToken, WinDef.DWORD dwFlags, char[] pszPath)` Takes the CSIDL of a folder and returns the path.
    `boolean` | `SHGetSpecialFolderPath(WinDef.HWND owner, char[] path, int csidl, boolean create)` Retrieves the path of a special folder, identified by its CSIDL.

- - ### Field Detail

    - #### INSTANCE

          static final Shell32 INSTANCE

  - ### Method Detail

    - #### SHFileOperation

          int SHFileOperation(ShellAPI.SHFILEOPSTRUCT fileop)

      This function can be used to copy, move, rename, or delete a file system object.
      Parameters:
        `fileop` - Address of an SHFILEOPSTRUCT structure that contains information this function needs to carry out the specified operation.
      Returns:
        Returns zero if successful, or nonzero otherwise.

    - #### SHGetFolderPath

          WinNT.HRESULT SHGetFolderPath(WinDef.HWND hwndOwner,
                                      int nFolder,
                                      WinNT.HANDLE hToken,
                                      WinDef.DWORD dwFlags,
                                      char[] pszPath)

      Takes the CSIDL of a folder and returns the path.
      Parameters:
        `hwndOwner` - Handle to an owner window. This parameter is typically set to NULL. If it is not NULL, and a dial-up connection needs to be made to access the folder, a user interface (UI) prompt will appear in this window.
        `nFolder` - A CSIDL value that identifies the folder whose path is to be retrieved. Only real folders are valid. If a virtual folder is specified, this function will fail. You can force creation of a folder with SHGetFolderPath by combining the folder's CSIDL with CSIDL_FLAG_CREATE.
        `hToken` - An access token that can be used to represent a particular user.
        `dwFlags` - Flags to specify which path is to be returned.
        `pszPath` - Pointer to a null-terminated string of length MAX_PATH which will receive the path. If an error occurs or S_FALSE is returned, this string will be empty.
      Returns:
        Returns standard HRESULT codes.

    - #### SHGetDesktopFolder

          WinNT.HRESULT SHGetDesktopFolder(PointerByReference ppshf)

      Retrieves the IShellFolder interface for the desktop folder, which is the root of the Shell's namespace. The retrieved COM interface pointer can be used via Com4JNA's ComObject.wrapNativeInterface call given a suitable interface definition for IShellFolder
      Parameters:
        `ppshf` - A place to put the IShellFolder interface pointer
      Returns:
        If the function succeeds, it returns S_OK. Otherwise, it returns an HRESULT error code.

    - #### ShellExecute

          WinDef.INT_PTR ShellExecute(WinDef.HWND hwnd,
                                    java.lang.String lpOperation,
                                    java.lang.String lpFile,
                                    java.lang.String lpParameters,
                                    java.lang.String lpDirectory,
                                    int nShowCmd)

      Performs an operation on a specified file.
      Parameters:
        `hwnd` - A handle to the owner window used for displaying a UI or error messages. This value can be NULL if the operation is not associated with a window.
        `lpOperation` - A pointer to a null-terminated string, referred to in this case as a verb, that specifies the action to be performed. The set of available verbs depends on the particular file or folder. Generally, the actions available from an object's shortcut menu are available verbs. The following verbs are commonly used: edit Launches an editor and opens the document for editing. If lpFile is not a document file, the function will fail. explore Explores a folder specified by lpFile. find Initiates a search beginning in the directory specified by lpDirectory. open Opens the item specified by the lpFile parameter. The item can be a file or folder. print Prints the file specified by lpFile. If lpFile is not a document file, the function fails. NULL In systems prior to Windows 2000, the default verb is used if it is valid and available in the registry. If not, the "open" verb is used. In Windows 2000 and later, the default verb is used if available. If not, the "open" verb is used. If neither verb is available, the system uses the first verb listed in the registry.
        `lpFile` - A pointer to a null-terminated string that specifies the file or object on which to execute the specified verb. To specify a Shell namespace object, pass the fully qualified parse name. Note that not all verbs are supported on all objects. For example, not all document types support the "print" verb. If a relative path is used for the lpDirectory parameter do not use a relative path for lpFile.
        `lpParameters` - If lpFile specifies an executable file, this parameter is a pointer to a null-terminated string that specifies the parameters to be passed to the application. The format of this string is determined by the verb that is to be invoked. If lpFile specifies a document file, lpParameters should be NULL.
        `lpDirectory` - A pointer to a null-terminated string that specifies the default (working) directory for the action. If this value is NULL, the current working directory is used. If a relative path is provided at lpFile, do not use a relative path for lpDirectory.
        `nShowCmd` - The flags that specify how an application is to be displayed when it is opened. If lpFile specifies a document file, the flag is simply passed to the associated application. It is up to the application to decide how to handle it.
      Returns:
        If the function succeeds, it returns a value greater than 32. If the function fails, it returns an error value that indicates the cause of the failure. The return value is cast as an HINSTANCE for backward compatibility with 16-bit Windows applications. It is not a true HINSTANCE, however. It can be cast only to an int and compared to either 32 or the following error codes below.

        NOTE: `WinDef.INT_PTR` is used instead of HINSTANCE here, since the former fits the reutrn type's actual usage more closely. 0 The operating system is out of memory or resources. ERROR_FILE_NOT_FOUND The specified file was not found. ERROR_PATH_NOT_FOUND The specified path was not found. ERROR_BAD_FORMAT The .exe file is invalid (non-Win32 .exe or error in .exe image). SE_ERR_ACCESSDENIED The operating system denied access to the specified file. SE_ERR_ASSOCINCOMPLETE The file name association is incomplete or invalid. SE_ERR_DDEBUSY The DDE transaction could not be completed because other DDE transactions were being processed. SE_ERR_DDEFAIL The DDE transaction failed. SE_ERR_DDETIMEOUT The DDE transaction could not be completed because the request timed out. SE_ERR_DLLNOTFOUND The specified DLL was not found. SE_ERR_FNF The specified file was not found. SE_ERR_NOASSOC There is no application associated with the given file name extension. This error will also be returned if you attempt to print a file that is not printable. SE_ERR_OOM There was not enough memory to complete the operation. SE_ERR_PNF The specified path was not found. SE_ERR_SHARE A sharing violation occurred.

    - #### SHGetSpecialFolderPath

          boolean SHGetSpecialFolderPath(WinDef.HWND owner,
                                       char[] path,
                                       int csidl,
                                       boolean create)

      Retrieves the path of a special folder, identified by its CSIDL.
      Parameters:
        `owner` - Reserved.
        `path` - A pointer to a null-terminated string that receives the drive and path of the specified folder. This buffer must be at least MAX_PATH characters in size.
        `csidl` - A CSIDL that identifies the folder of interest. If a virtual folder is specified, this function will fail.
        `create` - Indicates whether the folder should be created if it does not already exist. If this value is nonzero, the folder is created. If this value is zero, the folder is not created.
      Returns:
        `true` if successful; otherwise, `false`.

    - #### SHAppBarMessage

          WinDef.UINT_PTR SHAppBarMessage(WinDef.DWORD dwMessage,
                                        ShellAPI.APPBARDATA pData)

      SHAppBarMessage function
      Parameters:
        `dwMessage` - Appbar message value to send. This parameter can be one of the following values. `ShellAPI.ABM_NEW` Registers a new appbar and specifies the message identifier that the system should use to send notification messages to the appbar. `ShellAPI.ABM_REMOVE` Unregisters an appbar, removing the bar from the system's internal list. `ShellAPI.ABM_QUERYPOS` Requests a size and screen position for an appbar. `ShellAPI.ABM_SETPOS` Sets the size and screen position of an appbar. `ShellAPI.ABM_GETSTATE` Retrieves the autohide and always-on-top states of the Windows taskbar. `ShellAPI.ABM_GETTASKBARPOS` Retrieves the bounding rectangle of the Windows taskbar. Note that this applies only to the system taskbar. Other objects, particularly toolbars supplied with third-party software, also can be present. As a result, some of the screen area not covered by the Windows taskbar might not be visible to the user. To retrieve the area of the screen not covered by both the taskbar and other app barsÑthe working area available to your applicationÑ, use the GetMonitorInfo function. `ShellAPI.ABM_ACTIVATE` Notifies the system to activate or deactivate an appbar. The lParam member of the APPBARDATA pointed to by pData is set to TRUE to activate or FALSE to deactivate. `ShellAPI.ABM_GETAUTOHIDEBAR` Retrieves the handle to the autohide appbar associated with a particular edge of the screen. `ShellAPI.ABM_SETAUTOHIDEBAR` Registers or unregisters an autohide appbar for an edge of the screen. `ShellAPI.ABM_WINDOWPOSCHANGED` Notifies the system when an appbar's position has changed. `ShellAPI.ABM_SETSTATE` Windows XP and later: Sets the state of the appbar's autohide and always-on-top attributes.
        `pData` - A pointer to an APPBARDATA structure. The content of the structure on entry and on exit depends on the value set in the dwMessage parameter. See the individual message pages for specifics.
      Returns:
        This function returns a message-dependent value. For more information, see the Windows SDK documentation for the specific appbar message sent.
      See Also:
        ABM_NEW, ABM_REMOVE, ABM_QUERYPOS, ABM_SETPOS, ABM_GETSTATE, ABM_GETTASKBARPOS, ABM_ACTIVATE, ABM_GETAUTOHIDEBAR, ABM_SETAUTOHIDEBAR, ABM_WINDOWPOSCHANGED, ABM_SETSTATE

Copyright © 2007-2013 Timothy Wall. All Rights Reserved.